Subject: Re: bug#7102: 23.2; Makefile fontification incorrect

From: Stefan Monnier <[email-masked]>
Date: Sun, 26 Sep 2010 22:17:18 +0200

>> Start Emacs with `emacs -Q'.
>> Open `gmake.defs' in `nt/' directory.
>>> From line 99 on the rest of the file is fontified mostly as comments.
>> Note: Removing 1 of the double quotes at the end of line 99 results in correct
>> fontification of the buffer.

> I know nothing about this code, but since the comment in the line
> above says that it contains a deliberate syntax error, maybe
> makefile-mode can be forgiven for getting confused.

The problem is that makefile-mode assumes all the Makefil content
follows the lexical rules of Make, whereas $(shell ...) does not follow
the Make lexical rules in "...", so (as in the present case) the "..."
may contain unmatched double quotes.  I don't actually know how the end
of "..." is determined, tho I guess it's something like "the matching
close-paren" probably with the possibility to escape parens
with backslashes.

        Stefan